/*
  File autogenerated by gengetopt version 2.15
  generated with the following command:
  gengetopt --unamed-opts --no-handle-version --no-handle-help --no-handle-error 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "cmdline.h"

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);


static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->forward_given = 0 ;
  args_info->reverse_given = 0 ;
  args_info->both_strands_given = 0 ;
  args_info->outfile_given = 0 ;
  args_info->window_given = 0 ;
  args_info->cutoff_given = 0 ;
  args_info->show_gaps_given = 0 ;
  args_info->predict_strand_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->forward_flag = 0;
  args_info->reverse_flag = 0;
  args_info->both_strands_flag = 0;
  args_info->outfile_arg = NULL;
  args_info->outfile_orig = NULL;
  args_info->window_arg = NULL;
  args_info->window_orig = NULL;
  args_info->cutoff_orig = NULL;
  args_info->show_gaps_flag = 0;
  args_info->predict_strand_flag = 0;
  
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\nUsage: %s [OPTIONS]... [FILES]...\n\n", CMDLINE_PARSER_PACKAGE);
  printf("%s\n","  -h, --help            Print help and exit");
  printf("%s\n","  -V, --version         Print version and exit");
  printf("%s\n","  -f, --forward         Score forward strand  (default=off)");
  printf("%s\n","  -r, --reverse         Score reverse strand  (default=off)");
  printf("%s\n","  -b, --both-strands    Score both strands  (default=off)");
  printf("%s\n","  -o, --outfile=STRING  Output filename");
  printf("%s\n","  -w, --window=STRING   Score window");
  printf("%s\n","  -p, --cutoff=FLOAT    Probability cutoff");
  printf("%s\n","  -g, --show-gaps       Display alignment with gap  (default=off)");
  printf("%s\n","  -s, --predict-strand  Use strand predictor  (default=off)");
  
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);

  args_info->inputs = NULL;
  args_info->inputs_num = 0;
}

static void
cmdline_parser_release (struct gengetopt_args_info *args_info)
{
  
  unsigned int i;
  if (args_info->outfile_arg)
    {
      free (args_info->outfile_arg); /* free previous argument */
      args_info->outfile_arg = 0;
    }
  if (args_info->outfile_orig)
    {
      free (args_info->outfile_orig); /* free previous argument */
      args_info->outfile_orig = 0;
    }
  if (args_info->window_arg)
    {
      free (args_info->window_arg); /* free previous argument */
      args_info->window_arg = 0;
    }
  if (args_info->window_orig)
    {
      free (args_info->window_orig); /* free previous argument */
      args_info->window_orig = 0;
    }
  if (args_info->cutoff_orig)
    {
      free (args_info->cutoff_orig); /* free previous argument */
      args_info->cutoff_orig = 0;
    }
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);
  
  if (args_info->inputs_num)
    free (args_info->inputs);
  
  clear_given (args_info);
}

int
cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  if (args_info->help_given) {
    fprintf(outfile, "%s\n", "help");
  }
  if (args_info->version_given) {
    fprintf(outfile, "%s\n", "version");
  }
  if (args_info->forward_given) {
    fprintf(outfile, "%s\n", "forward");
  }
  if (args_info->reverse_given) {
    fprintf(outfile, "%s\n", "reverse");
  }
  if (args_info->both_strands_given) {
    fprintf(outfile, "%s\n", "both-strands");
  }
  if (args_info->outfile_given) {
    if (args_info->outfile_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "outfile", args_info->outfile_orig);
    } else {
      fprintf(outfile, "%s\n", "outfile");
    }
  }
  if (args_info->window_given) {
    if (args_info->window_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "window", args_info->window_orig);
    } else {
      fprintf(outfile, "%s\n", "window");
    }
  }
  if (args_info->cutoff_given) {
    if (args_info->cutoff_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "cutoff", args_info->cutoff_orig);
    } else {
      fprintf(outfile, "%s\n", "cutoff");
    }
  }
  if (args_info->show_gaps_given) {
    fprintf(outfile, "%s\n", "show-gaps");
  }
  if (args_info->predict_strand_given) {
    fprintf(outfile, "%s\n", "predict-strand");
  }
  
  fclose (outfile);

  i = EXIT_SUCCESS;
  return i;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  cmdline_parser_release (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;

  result = cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  return result;
}

int
cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name)
{
  return EXIT_SUCCESS;
}

int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "forward",	0, NULL, 'f' },
        { "reverse",	0, NULL, 'r' },
        { "both-strands",	0, NULL, 'b' },
        { "outfile",	1, NULL, 'o' },
        { "window",	1, NULL, 'w' },
        { "cutoff",	1, NULL, 'p' },
        { "show-gaps",	0, NULL, 'g' },
        { "predict-strand",	0, NULL, 's' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVfrbo:w:p:gs", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          if (local_args_info.help_given)
            {
              fprintf (stderr, "%s: `--help' (`-h') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->help_given && ! override)
            continue;
          local_args_info.help_given = 1;
          args_info->help_given = 1;
          cmdline_parser_free (&local_args_info);
          return 0;

        case 'V':	/* Print version and exit.  */
          if (local_args_info.version_given)
            {
              fprintf (stderr, "%s: `--version' (`-V') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->version_given && ! override)
            continue;
          local_args_info.version_given = 1;
          args_info->version_given = 1;
          cmdline_parser_free (&local_args_info);
          return 0;

        case 'f':	/* Score forward strand.  */
          if (local_args_info.forward_given)
            {
              fprintf (stderr, "%s: `--forward' (`-f') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->forward_given && ! override)
            continue;
          local_args_info.forward_given = 1;
          args_info->forward_given = 1;
          args_info->forward_flag = !(args_info->forward_flag);
          break;

        case 'r':	/* Score reverse strand.  */
          if (local_args_info.reverse_given)
            {
              fprintf (stderr, "%s: `--reverse' (`-r') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->reverse_given && ! override)
            continue;
          local_args_info.reverse_given = 1;
          args_info->reverse_given = 1;
          args_info->reverse_flag = !(args_info->reverse_flag);
          break;

        case 'b':	/* Score both strands.  */
          if (local_args_info.both_strands_given)
            {
              fprintf (stderr, "%s: `--both-strands' (`-b') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->both_strands_given && ! override)
            continue;
          local_args_info.both_strands_given = 1;
          args_info->both_strands_given = 1;
          args_info->both_strands_flag = !(args_info->both_strands_flag);
          break;

        case 'o':	/* Output filename.  */
          if (local_args_info.outfile_given)
            {
              fprintf (stderr, "%s: `--outfile' (`-o') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->outfile_given && ! override)
            continue;
          local_args_info.outfile_given = 1;
          args_info->outfile_given = 1;
          if (args_info->outfile_arg)
            free (args_info->outfile_arg); /* free previous string */
          args_info->outfile_arg = gengetopt_strdup (optarg);
          if (args_info->outfile_orig)
            free (args_info->outfile_orig); /* free previous string */
          args_info->outfile_orig = gengetopt_strdup (optarg);
          break;

        case 'w':	/* Score window.  */
          if (local_args_info.window_given)
            {
              fprintf (stderr, "%s: `--window' (`-w') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->window_given && ! override)
            continue;
          local_args_info.window_given = 1;
          args_info->window_given = 1;
          if (args_info->window_arg)
            free (args_info->window_arg); /* free previous string */
          args_info->window_arg = gengetopt_strdup (optarg);
          if (args_info->window_orig)
            free (args_info->window_orig); /* free previous string */
          args_info->window_orig = gengetopt_strdup (optarg);
          break;

        case 'p':	/* Probability cutoff.  */
          if (local_args_info.cutoff_given)
            {
              fprintf (stderr, "%s: `--cutoff' (`-p') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->cutoff_given && ! override)
            continue;
          local_args_info.cutoff_given = 1;
          args_info->cutoff_given = 1;
          args_info->cutoff_arg = (float)strtod (optarg, &stop_char);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->cutoff_orig)
            free (args_info->cutoff_orig); /* free previous string */
          args_info->cutoff_orig = gengetopt_strdup (optarg);
          break;

        case 'g':	/* Display alignment with gap.  */
          if (local_args_info.show_gaps_given)
            {
              fprintf (stderr, "%s: `--show-gaps' (`-g') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->show_gaps_given && ! override)
            continue;
          local_args_info.show_gaps_given = 1;
          args_info->show_gaps_given = 1;
          args_info->show_gaps_flag = !(args_info->show_gaps_flag);
          break;

        case 's':	/* Use strand predictor.  */
          if (local_args_info.predict_strand_given)
            {
              fprintf (stderr, "%s: `--predict-strand' (`-s') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->predict_strand_given && ! override)
            continue;
          local_args_info.predict_strand_given = 1;
          args_info->predict_strand_given = 1;
          args_info->predict_strand_flag = !(args_info->predict_strand_flag);
          break;


        case 0:	/* Long option with no short option */
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */




  cmdline_parser_release (&local_args_info);

  if ( error )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;

      args_info->inputs_num = argc - optind ;
      args_info->inputs =
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind++]) ;
    }

  return 0;

failure:
  
  cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
